## apr-util 1.4.1

=== debian/changelog ===
apr-util (1.4.1-3) unstable; urgency=low

  * Fix apr_password_validate() to work with sha512-crypt hashes.
    Closes: #684268

 -- Stefan Fritsch <sf@debian.org>  Wed, 15 Aug 2012 20:10:55 +0200

apr-util (1.4.1-2) unstable; urgency=low

  * Remove obsolete version on binutils dependency. Closes: #666260
  * Re-enable test suite on hurd. Closes: #657043
  * Switch VCS to git
  * Switch to packaging format "3.0 quilt", remove dpatch. Thanks to Jari
    Aalto for the patch. Closes: #664307
  * Update to Standards-Version to 3.9.3 (no changes)
  * Bump to debhelper 9.
  * Remove obsolete workaround for #651147, ldap detection is fixed in 1.4.x
  * Fix lintian warnings
    - use dh_prep
    - omit driver libraries from symbol files
    - add build-arch and build-indep targets

 -- Stefan Fritsch <sf@debian.org>  Sun, 20 May 2012 22:14:38 +0200

apr-util (1.4.1-1) unstable; urgency=low

  * New upstream release
  * Build new apr_crypto API (using openssl).
  * Stop repacking the source tarball to remove the MD4/MD5 implementations
    derived from RSA's code. RSA has released a statement that revised the
    conditions of use for this code. Debian uses the code according to the
    conditions from this statement, which is now included in the copyright
    file of the Debian package.

 -- Stefan Fritsch <sf@debian.org>  Sun, 08 Jan 2012 20:44:17 +0100

apr-util (1.3.12+dfsg-3) unstable; urgency=high

  * Add workaround for ldap detection problem, to fix FTBFS with gcc 4.6.
    Closes: #651147
  * Remove Tollef Fog Heen and Ryan Niebur from uploaders. Thanks for your
    work in the past.

 -- Stefan Fritsch <sf@debian.org>  Wed, 07 Dec 2011 20:25:16 +0100

apr-util (1.3.12+dfsg-2) unstable; urgency=low

  * Fix unsafe pool usage in apr_thread_pool. This hopefully fixes the
    occasional testreslist failures.

 -- Stefan Fritsch <sf@debian.org>  Sun, 22 May 2011 20:37:08 +0200

apr-util (1.3.12+dfsg-1) unstable; urgency=low

  * New upstream version
  * Make apu-config not output dbm libs by default. Closes: #622081
  * Set DEB_GCC_NO_O3=1 for the benefit of ppc64 on Ubuntu.

 -- Stefan Fritsch <sf@debian.org>  Sun, 22 May 2011 01:27:59 +0200

apr-util (1.3.10+dfsg-2) unstable; urgency=low

  * Remove libdb4.8-dev dependency in libaprutil1-dev. This allows packages
    build-depending on apr-util1 to use a different version of db than
    apr-util.
  * With the libdb build-dependency decoupled from subversion, we can now
    build-depend on libdb-dev instead of libdb4.8-dev. Users of APU_WANT_DB
    in apu_want.h would have to depend on libdb-dev explicitly, but there
    are none outside of apr-util itself. Closes: #621366
  * Add configure support for libdb 5.1.
  * Bump standards version to 3.9.2 (no changes)
  * Fix some lintian warnings about the short descriptions.

 -- Stefan Fritsch <sf@debian.org>  Fri, 08 Apr 2011 19:19:23 +0200

apr-util (1.3.10+dfsg-1) unstable; urgency=low

  * New upstream release.
  * Add ${misc:Depends} to Depends.
  * Remove some old Conflicts and Breaks.
  * Bump standards version to 3.9.1:
    - empty dependency_libs section in libaprutil-1.la

 -- Stefan Fritsch <sf@debian.org>  Tue, 08 Feb 2011 22:53:01 +0100

apr-util (1.3.9+dfsg-5) unstable; urgency=low

  * Backports from 1.3.10:
    - apr_thread_pool: Fix some potential deadlock situations.  PR 49709.
    - apr_thread_pool_create: Fix pool corruption caused by multithreaded
      use of the pool when multiple initial threads are created.  PR 47843.
    - apr_thread_pool_create: Only set the output variable on success.

 -- Stefan Fritsch <sf@debian.org>  Fri, 01 Oct 2010 22:05:54 +0200

apr-util (1.3.9+dfsg-4) unstable; urgency=high

  * CVE-2010-1623: Fix denial of service vulnerability through memory
    consumption in apr_brigade_split_line()

 -- Stefan Fritsch <sf@debian.org>  Fri, 01 Oct 2010 18:19:38 +0200

apr-util (1.3.9+dfsg-3) unstable; urgency=low

  * Update to db4.8 (closes: #550443)
  * Bump standards-version:
    - Use DEB_*_ARCH_* where applicable

 -- Stefan Fritsch <sf@debian.org>  Sun, 01 Nov 2009 10:40:53 +0100

apr-util (1.3.9+dfsg-2) unstable; urgency=low

  * Fix FTBFS (closes: #545718). The FTBFS didn't happen with dash as /bin/sh
    due to dash bug #514863.
  * Ship the html documentation in the -dev package. Thanks to Joel Smith for
    the patch (closes: #543554).
  * Make libaprutil1-dev depend on libmysqlclient-dev instead of
    libmysqlclient15-dev.

 -- Stefan Fritsch <sf@debian.org>  Sat, 12 Sep 2009 15:04:55 +0200

apr-util (1.3.9+dfsg-1) unstable; urgency=high

  [ Stefan Fritsch ]
  * Enable -fstack-protector for arm/armel. A workaround has been added to
    gcc.
  * Remove obsolete libmysqlclient15off dependency. Update build-dep to
    libmysqlclient-dev.

  [ Peter Samuelson ]
  * New upstream security release.
    - Fix CVE-2009-2412, overflow in RMM allocations due to alignment.
  * Add myself to Uploaders.

 -- Peter Samuelson <peter@p12n.org>  Thu, 06 Aug 2009 13:21:48 -0500

apr-util (1.3.8+dfsg-1) unstable; urgency=low

  * New upstream version.
  * Add two CVE ids to 1.3.7+dfsg-1 changelog entry.
  * Bump standards version (no changes).
  * Make libaprutil1-dbd-sqlite3 the default dbd driver, to reduce the size
    of dependencies pulled in by apache2.2-bin by default (closes: #536466)

 -- Stefan Fritsch <sf@debian.org>  Sat, 25 Jul 2009 20:08:37 +0200

apr-util (1.3.7+dfsg-1) unstable; urgency=high

  * New upstream version:
    - CVE-2009-0023: Fix underflow in apr_strmatch_precompile() which causes
      remotely exploitable DoS vulnerabilities in mod_dav_svn and libapreq2.
    - CVE-2009-1955: Fix DoS vulnerability (memory consumption) in handling of
      internal xml entities.
    - CVE-2009-1956: Fix off by one overflow in apr_brigade_vprintf.
  * Disable test suite on hurd for now (closes: #530287).
  * Override lintian warning about soname.

 -- Stefan Fritsch <sf@debian.org>  Thu, 04 Jun 2009 20:53:47 +0200



=== debian/rules ===
#!/usr/bin/make -f

# Turn on VERBOSE output
#export DH_VERBOSE=1
export DH_OPTIONS

# for ppc64 on Ubuntu
export DEB_GCC_NO_O3=1

# These are used for cross-compiling and for saving the configure script
# # from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# get cflags frpm apr-config but remove -O2
CFLAGS := $(CFLAGS) $(shell apr-1-config --cflags |perl -p -e 's!-O.( |$$)!!')
LDFLAGS := $(LDFLAGS) $(shell apr-1-config --ldflags)

# hardening options
H_CFLAGS := -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector
H_LDFLAGS := -Wl,-z,relro

# Enable debug builds
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
  CFLAGS += -O0
else
  ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    CFLAGS += -O0
  else
    CFLAGS += -O2
  endif
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(NUMJOBS)
endif

ifeq (,$(findstring notest,$(DEB_BUILD_OPTIONS))$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	TEST_TARGET = test
else
	TEST_TARGET =
endif

ifeq ($(DEB_BUILD_ARCH),i386)
	CONFFLAGS=apr_lock_method=USE_PROC_PTHREAD_SERIALIZE
else
	CONFFLAGS=ac_cv_func_pthread_mutexattr_setpshared=no ac_cv_func_sem_open=no
endif

CONFFLAGS += ac_cv_prog_AWK=mawk

SHELL=/bin/bash

config.status: configure.in
	dh_testdir
	./buildconf --with-apr=$(shell apr-1-config --srcdir)
	$(CONFFLAGS) ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --enable-layout=Debian --with-apr=/usr/bin/apr-1-config --with-ldap=yes --with-dbm=db --with-sqlite3 --with-pgsql=/usr --without-gdbm --without-sqlite2 --with-berkeley-db --with-mysql=/usr --with-freetds=/usr --with-odbc=/usr --with-openssl=/usr

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: config.status
	dh_testdir

	# LDFLAGS=-Wl,--as-needed does not work since it affects only libraries
	# given _after_ it on the command line, but apr's libtool puts the 
	# "-l..." _before_ the "-Wl,--as-needed"
	$(MAKE) CFLAGS="$(CFLAGS) $(H_CFLAGS)" LDFLAGS="$(LDFLAGS) $(H_LDFLAGS)" EXTRA_CFLAGS=""
	$(MAKE) dox

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp test-stamp
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f test/data/test-db test/data/test-sdbm.dir test/data/test-sdbm.pag
	rm -f xml/expat/aclocal.m4 xml/expat/configure xml/expat/conftools/ltmain.sh
	rm -f build-outputs.mk build/apr_common.m4 build/config.guess build/config.sub config.nice configure config.log
	rm -rf docs/dox

	dh_clean

test: test-stamp

test-stamp: build
	dh_testdir
	$(MAKE) -j 1 check

	touch $@

install: build $(TEST_TARGET)
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs -a

	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	perl -p -i -e "s,^dependency_libs=.*,dependency_libs=''," $(CURDIR)/debian/tmp/usr/lib/libaprutil-1.la

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_lintian
	dh_install -a
	dh_link
	dh_strip --dbg-package=libaprutil1-dbg
	dh_compress
	dh_fixperms
	dh_makeshlibs -plibaprutil1 -X/apr-util-1/
	dh_makeshlibs -n -Nlibaprutil1
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## apr-util 1.5.2

=== debian/changelog ===
apr-util (1.5.2-1) unstable; urgency=low

  * New upstream release.
  * Ship find_apu.m4 in libaprutil1-dev. Closes: #699327

 -- Stefan Fritsch <sf@debian.org>  Sun, 05 May 2013 15:43:34 +0200

=== debian/rules ===
--- 
+++ 
@@ -55,7 +55,7 @@
 config.status: configure.in
 	dh_testdir
 	./buildconf --with-apr=$(shell apr-1-config --srcdir)
-	$(CONFFLAGS) ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --enable-layout=Debian --with-apr=/usr/bin/apr-1-config --with-ldap=yes --with-dbm=db --with-sqlite3 --with-pgsql=/usr --without-gdbm --without-sqlite2 --with-berkeley-db --with-mysql=/usr --with-freetds=/usr --with-odbc=/usr --with-openssl=/usr
+	$(CONFFLAGS) ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --enable-layout=Debian --with-apr=/usr/bin/apr-1-config --with-ldap=yes --with-dbm=db --with-sqlite3 --with-pgsql=/usr --without-gdbm --without-sqlite2 --with-berkeley-db --with-mysql=/usr --with-freetds=/usr --with-odbc=/usr --with-openssl=/usr --with-crypto
 
 build: build-arch build-indep
 build-arch: build-stamp

## apr-util 1.5.3

=== CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Read README.cmake before using this.

PROJECT(APR-Util C)

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

FIND_PACKAGE(OpenSSL)

OPTION(APU_HAVE_CRYPTO      "Crypto support"                            OFF)
OPTION(APU_HAVE_ODBC        "Build ODBC DBD driver"                     ON)
OPTION(APR_HAS_LDAP         "LDAP support"                              ON)
OPTION(INSTALL_PDB          "Install .pdb files (if generated)"         ON)
OPTION(APR_BUILD_TESTAPR    "Build the test suite"                      OFF)
OPTION(TEST_STATIC_LIBS     "Test programs use APR static libraries instead of shared libraries?" OFF)
SET(APR_INCLUDE_DIR         "${CMAKE_INSTALL_PREFIX}/include"           CACHE STRING "Directory with APR include files")
SET(APR_LIBRARIES           "${CMAKE_INSTALL_PREFIX}/lib/libapr-1.lib"  CACHE STRING "APR library to link with")

IF(NOT EXISTS "${APR_INCLUDE_DIR}/apr.h")
  MESSAGE(FATAL_ERROR "APR include directory ${APR_INCLUDE_DIR} is not correct.")
ENDIF()
FOREACH(onelib ${APR_LIBRARIES})
  IF(NOT EXISTS ${onelib})
    MESSAGE(FATAL_ERROR "APR library ${onelib} was not found.")
  ENDIF()
ENDFOREACH()

IF(APU_HAVE_CRYPTO)
IF(NOT OPENSSL_FOUND)
  MESSAGE(FATAL_ERROR "OpenSSL is the only supported crypto implementation, and it wasn't found!")
ENDIF()
ENDIF()

# create 1-or-0 representation of feature tests for apu.h

SET(apu_have_crypto_10 0)
SET(apu_have_apr_iconv_10 0) # not yet implemented
SET(apr_has_ldap_10 0)

IF(APU_HAVE_CRYPTO)
  SET(apu_have_crypto_10 1)
ENDIF()

IF(APR_HAS_LDAP)
  SET(apr_has_ldap_10 1)
ENDIF()

CONFIGURE_FILE(include/apu.hwc
              ${PROJECT_BINARY_DIR}/apu.h)
CONFIGURE_FILE(include/apr_ldap.hwc
              ${PROJECT_BINARY_DIR}/apr_ldap.h)
# "COPYONLY" just because anything else isn't implemented ;)
CONFIGURE_FILE(include/private/apu_config.hw
               ${PROJECT_BINARY_DIR}/apu_config.h
               COPYONLY)
CONFIGURE_FILE(include/private/apu_select_dbm.hw
               ${PROJECT_BINARY_DIR}/apu_select_dbm.h
               COPYONLY)
CONFIGURE_FILE(include/apu_want.hw
               ${PROJECT_BINARY_DIR}/apu_want.h
               COPYONLY)

SET(XMLLIB_INCLUDE_DIR   ${CMAKE_CURRENT_SOURCE_DIR}/xml/expat/lib)
SET(XMLLIB_LIBRARIES     libexpat)

SET(LDAP_LIBRARIES)
IF(APR_HAS_LDAP)
  SET(LDAP_LIBRARIES wldap32)
ENDIF()

# Generated .h files are stored in PROJECT_BINARY_DIR, not the
# source tree.
#
# BROKEN: not searching PROJECT_BINARY_DIR first, so you have to
#         manually delete apu.h in PROJECT_SOURCE_DIR/include if
#         you've generated apu.h before using a different build

SET(APR_INCLUDE_DIRECTORIES
  ${PROJECT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}/include/private
  ${APR_INCLUDE_DIR}
)

INCLUDE_DIRECTORIES(${APR_INCLUDE_DIRECTORIES} ${XMLLIB_INCLUDE_DIR})

SET(APR_PUBLIC_HEADERS_STATIC
  include/apr_anylock.h
  include/apr_base64.h
  include/apr_buckets.h
  include/apr_crypto.h
  include/apr_date.h
  include/apr_dbd.h
  include/apr_dbm.h
  include/apr_hooks.h
  include/apr_ldap_init.h
  include/apr_ldap_option.h
  include/apr_ldap_rebind.h
  include/apr_ldap_url.h
  include/apr_md4.h
  include/apr_md5.h
  include/apr_memcache.h
  include/apr_optional.h
  include/apr_optional_hooks.h
  include/apr_queue.h
  include/apr_reslist.h
  include/apr_rmm.h
  include/apr_sdbm.h
  include/apr_sha1.h
  include/apr_strmatch.h
  include/apr_thread_pool.h
  include/apr_uri.h
  include/apr_uuid.h
  include/apr_xlate.h
  include/apr_xml.h
  include/apu_errno.h
  include/apu_version.h
)

# apu_config.h and apu_select_dbm.h are private
SET(APR_PUBLIC_HEADERS_GENERATED
  ${PROJECT_BINARY_DIR}/apu.h
  ${PROJECT_BINARY_DIR}/apr_ldap.h
  ${PROJECT_BINARY_DIR}/apu_want.h
)

SET(APR_SOURCES
  buckets/apr_brigade.c
  buckets/apr_buckets.c
  buckets/apr_buckets_alloc.c
  buckets/apr_buckets_eos.c
  buckets/apr_buckets_file.c
  buckets/apr_buckets_flush.c
  buckets/apr_buckets_heap.c
  buckets/apr_buckets_mmap.c
  buckets/apr_buckets_pipe.c
  buckets/apr_buckets_pool.c
  buckets/apr_buckets_refcount.c
  buckets/apr_buckets_simple.c
  buckets/apr_buckets_socket.c
  crypto/apr_crypto.c
  crypto/apr_md4.c
  crypto/apr_md5.c
  crypto/apr_passwd.c
  crypto/apr_sha1.c
  crypto/crypt_blowfish.c
  crypto/getuuid.c
  crypto/uuid.c
  dbd/apr_dbd.c
  dbm/apr_dbm.c
  dbm/apr_dbm_sdbm.c
  dbm/sdbm/sdbm.c
  dbm/sdbm/sdbm_hash.c
  dbm/sdbm/sdbm_lock.c
  dbm/sdbm/sdbm_pair.c
  encoding/apr_base64.c
  hooks/apr_hooks.c
  memcache/apr_memcache.c
  misc/apr_date.c
  misc/apr_queue.c
  misc/apr_reslist.c
  misc/apr_rmm.c
  misc/apr_thread_pool.c
  misc/apu_dso.c
  misc/apu_version.c
  strmatch/apr_strmatch.c
  uri/apr_uri.c
  xlate/xlate.c
  xml/apr_xml.c
)

IF(APR_HAS_LDAP)
  SET(APR_SOURCES ${APR_SOURCES} ldap/apr_ldap_stub.c ldap/apr_ldap_url.c)
ENDIF()

SET(APR_TEST_SOURCES
  test/abts.c
  test/testbuckets.c
  test/testcrypto.c
  test/testdate.c
  test/testdbd.c
  test/testdbm.c
  test/testldap.c
  test/testmd4.c
  test/testmd5.c
  test/testmemcache.c
  test/testpass.c
  test/testqueue.c
  test/testreslist.c
  test/testrmm.c
  test/teststrmatch.c
  test/testuri.c
  test/testutil.c
  test/testuuid.c
  test/testxlate.c
  test/testxml.c
)

SET(EXPAT_SOURCES
  xml/expat/lib/xmlrole.c
  xml/expat/lib/xmltok.c
  xml/expat/lib/xmlparse.c
)

SET(install_targets)
SET(install_bin_pdb)
SET(install_lib_pdb)
SET(dbd_drivers)

# static expat (not installed)
ADD_LIBRARY(libexpat STATIC ${EXPAT_SOURCES})
SET_TARGET_PROPERTIES(libexpat PROPERTIES COMPILE_DEFINITIONS "XML_STATIC;COMPILED_FROM_DSP")

# libaprutil-1 is shared, aprutil-1 is static
ADD_LIBRARY(libaprutil-1 SHARED ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED} libaprutil.rc)
SET(install_targets ${install_targets} libaprutil-1)
SET(install_bin_pdb ${install_bin_pdb} ${PROJECT_BINARY_DIR}/libaprutil-1.pdb)
TARGET_LINK_LIBRARIES(libaprutil-1 ${APR_LIBRARIES} ${XMLLIB_LIBRARIES})
SET_TARGET_PROPERTIES(libaprutil-1 PROPERTIES COMPILE_DEFINITIONS "APU_DECLARE_EXPORT;XML_STATIC")

ADD_LIBRARY(aprutil-1 STATIC ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED})
SET(install_targets ${install_targets} aprutil-1)
SET(install_lib_pdb ${install_lib_pdb} ${PROJECT_BINARY_DIR}/aprutil-1.pdb)
TARGET_LINK_LIBRARIES(aprutil-1 ${APR_LIBRARIES} ${XMLLIB_LIBRARIES})
SET_TARGET_PROPERTIES(aprutil-1 PROPERTIES COMPILE_DEFINITIONS "APU_DECLARE_STATIC;APR_DECLARE_STATIC;APU_DSO_MODULE_BUILD;XML_STATIC")

IF(APU_HAVE_CRYPTO)
  IF(NOT OPENSSL_FOUND)
    MESSAGE(FATAL_ERROR "Only OpenSSL-based crypto is currently implemented in the cmake build")
  ENDIF()
  ADD_LIBRARY(apr_crypto_openssl-1 SHARED crypto/apr_crypto_openssl.c libaprutil.rc)
  SET(install_targets ${install_targets} apr_crypto_openssl-1)
  SET(install_bin_pdb ${install_bin_pdb} ${PROJECT_BINARY_DIR}/apr_crypto_openssl-1.pdb)
  SET_TARGET_PROPERTIES(apr_crypto_openssl-1 PROPERTIES INCLUDE_DIRECTORIES "${APR_INCLUDE_DIRECTORIES};${OPENSSL_INCLUDE_DIR}")
  SET_TARGET_PROPERTIES(apr_crypto_openssl-1 PROPERTIES COMPILE_FLAGS "-DDLL_NAME=\"\\\"apr_crypto_openssl\\\"\"")
  TARGET_LINK_LIBRARIES(apr_crypto_openssl-1 libaprutil-1 ${APR_LIBRARIES} ${OPENSSL_LIBRARIES})
ENDIF()

IF(APU_HAVE_ODBC)
  ADD_LIBRARY(apr_dbd_odbc-1 SHARED dbd/apr_dbd_odbc.c libaprutil.rc)
  SET(install_targets ${install_targets} apr_dbd_odbc-1)
  SET(install_bin_pdb ${install_bin_pdb} ${PROJECT_BINARY_DIR}/apr_dbd_odbc-1.pdb)
  SET(dbd_drivers ${dbd_drivers} odbc)
  TARGET_LINK_LIBRARIES(apr_dbd_odbc-1 libaprutil-1 ${APR_LIBRARIES} odbc32 odbccp32)
  SET_PROPERTY(TARGET apr_dbd_odbc-1 APPEND PROPERTY LINK_FLAGS /export:apr_dbd_odbc_driver)
  SET_TARGET_PROPERTIES(apr_dbd_odbc-1 PROPERTIES COMPILE_DEFINITIONS "APU_HAVE_ODBC;HAVE_SQL_H;APU_DECLARE_EXPORT;APU_DSO_MODULE_BUILD")
  SET_TARGET_PROPERTIES(apr_dbd_odbc-1 PROPERTIES COMPILE_FLAGS "-DDLL_NAME=\"\\\"apr_dbd_odbc\\\"\"")
ENDIF()

IF(APR_HAS_LDAP)
  ADD_LIBRARY(apr_ldap-1 SHARED ldap/apr_ldap_init.c ldap/apr_ldap_option.c 
              ldap/apr_ldap_rebind.c libaprutil.rc)
  SET(install_targets ${install_targets} apr_ldap-1)
  SET(install_bin_pdb ${install_bin_pdb} ${PROJECT_BINARY_DIR}/apr_ldap-1.pdb)
  TARGET_LINK_LIBRARIES(apr_ldap-1 libaprutil-1 ${APR_LIBRARIES} ${LDAP_LIBRARIES})
  SET_TARGET_PROPERTIES(apr_ldap-1 PROPERTIES COMPILE_FLAGS "-DDLL_NAME=\"\\\"apr_ldap\\\"\"")
  SET(apr_ldap_libraries apr_ldap-1)
ELSE()
  SET(apr_ldap_libraries)
ENDIF()

IF(APR_BUILD_TESTAPR)
  ENABLE_TESTING()
  # Create a "check" target that displays test program output to the console.
  ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND} --verbose)

  # copy data files to build directory so that we can run programs from there
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E make_directory 
                  ${PROJECT_BINARY_DIR}/data)
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E copy_if_different 
                  ${PROJECT_SOURCE_DIR}/test/data/billion-laughs.xml
                  ${PROJECT_BINARY_DIR}/data/billion-laughs.xml)

  IF(TEST_STATIC_LIBS)
    SET(whichapr    aprutil-1)
    SET(apiflag     "-DAPR_DECLARE_STATIC -DAPU_DECLARE_STATIC")
  ELSE()
    SET(whichapr    libaprutil-1)
    SET(apiflag)
  ENDIF()

  ADD_EXECUTABLE(testall ${APR_TEST_SOURCES})
  TARGET_LINK_LIBRARIES(testall ${whichapr} ${apr_ldap_libraries} ${XMLLIB_LIBRARIES} ${LDAP_LIBRARIES})
  IF(apiflag)
    SET_TARGET_PROPERTIES(testall PROPERTIES COMPILE_FLAGS ${apiflag})
  ENDIF()
  ADD_TEST(NAME testall COMMAND testall)

  ADD_EXECUTABLE(dbd test/dbd.c)
  TARGET_LINK_LIBRARIES(dbd ${whichapr})
  IF(apiflag)
    SET_TARGET_PROPERTIES(dbd PROPERTIES COMPILE_FLAGS ${apiflag})
  ENDIF()

  # dbd is run multiple times with different parameters.
  FOREACH(somedbd ${dbd_drivers})
    ADD_TEST(NAME dbd-${somedbd} COMMAND dbd ${somedbd})
  ENDFOREACH()

ENDIF (APR_BUILD_TESTAPR)

# Installation

INSTALL(TARGETS ${install_targets}
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
       )

IF(INSTALL_PDB)
  INSTALL(FILES ${install_bin_pdb}
          DESTINATION bin
          CONFIGURATIONS RelWithDebInfo Debug)

  INSTALL(FILES ${install_lib_pdb}
          DESTINATION lib
          CONFIGURATIONS RelWithDebInfo Debug)
ENDIF()

INSTALL(FILES ${APR_PUBLIC_HEADERS_STATIC} ${APR_PUBLIC_HEADERS_GENERATED} DESTINATION include)

STRING(TOUPPER "${CMAKE_BUILD_TYPE}" buildtype)
MESSAGE(STATUS "")
MESSAGE(STATUS "")
MESSAGE(STATUS "APR-Util configuration summary:")
MESSAGE(STATUS "")
MESSAGE(STATUS "  Build type ...................... : ${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "  Install .pdb (if available)...... : ${INSTALL_PDB}")
MESSAGE(STATUS "  Install prefix .................. : ${CMAKE_INSTALL_PREFIX}")
MESSAGE(STATUS "  C compiler ...................... : ${CMAKE_C_COMPILER}")
MESSAGE(STATUS "  APR include directory ........... : ${APR_INCLUDE_DIR}")
MESSAGE(STATUS "  APR libraries ................... : ${APR_LIBRARIES}")
MESSAGE(STATUS "  DBD ODBC driver ................. : ${APU_HAVE_ODBC}")
MESSAGE(STATUS "  APU_HAVE_CRYPTO ................. : ${APU_HAVE_CRYPTO}")
MESSAGE(STATUS "  APR_HAS_LDAP .................... : ${APR_HAS_LDAP}")
MESSAGE(STATUS "  Build test suite ................ : ${APR_BUILD_TESTAPR}")
IF(TEST_STATIC_LIBS)

=== debian/changelog ===
apr-util (1.5.3-1) unstable; urgency=low

  * New upstream version.
  * When querying the berkley db version, strip the epoch from the
    version number.

 -- Stefan Fritsch <sf@debian.org>  Sun, 24 Nov 2013 14:21:14 +0100

apr-util (1.5.2-2) unstable; urgency=low

  * Remove dbd-freetds driver because it has security issues.
  * Switch build system to dh.
  * Bump Standards-Version (no additional changes).
  * Support multi-arch.
  * Adjust dependencies to a multi-arch enabled apr.
  * Speed up build by not searching for lots of berkley db versions that
    are not installed. Closes: #717327

 -- Stefan Fritsch <sf@debian.org>  Wed, 06 Nov 2013 22:27:45 +0100

=== debian/control ===
Source: apr-util
Section: libs
Priority: optional
Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
Uploaders: Stefan Fritsch <sf@debian.org>, Peter Samuelson <peter@p12n.org>
Build-Depends: debhelper (>> 9~), autoconf, autotools-dev, mawk, libldap2-dev, libexpat1-dev, libdb-dev, libpcre3-dev, binutils, libapr1-dev (>> 1.4.8-2~), libsqlite3-dev, libpq-dev, python, libmysqlclient-dev, unixodbc-dev, doxygen, libssl-dev
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-apache/apr-util.git
Vcs-Git: git://git.debian.org/git/pkg-apache/apr-util.git
Homepage: http://apr.apache.org/

Package: libaprutil1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Breaks: libapr1 (<< 1.4.8-2~)
Description: Apache Portable Runtime Utility Library
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.

Package: libaprutil1-ldap
Architecture: any
Depends: libaprutil1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Apache Portable Runtime Utility Library - LDAP Driver
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains the LDAP driver.

Package: libaprutil1-dbd-mysql
Architecture: any
Depends: libaprutil1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Apache Portable Runtime Utility Library - MySQL Driver
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains the MySQL database driver.

Package: libaprutil1-dbd-sqlite3
Architecture: any
Depends: libaprutil1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Apache Portable Runtime Utility Library - SQLite3 Driver
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains the SQLite3 database driver.

Package: libaprutil1-dbd-odbc
Architecture: any
Depends: libaprutil1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Apache Portable Runtime Utility Library - ODBC Driver
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains the ODBC database driver.

Package: libaprutil1-dbd-pgsql
Architecture: any
Depends: libaprutil1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Apache Portable Runtime Utility Library - PostgreSQL Driver
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains the PostgreSQL database driver.

Package: libaprutil1-dev
Architecture: any
Section: libdevel
Depends: libaprutil1 (= ${binary:Version}), libldap2-dev, libexpat1-dev, libpcre3-dev, libapr1-dev (>= 1.2.2-1), libsqlite3-dev, libpq-dev, libmysqlclient-dev, ${misc:Depends}
Description: Apache Portable Runtime Utility Library - Development Headers
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains development headers for APR util.

Package: libaprutil1-dbg
Priority: extra
Architecture: any
Section: debug
Depends: libaprutil1 (= ${binary:Version}), ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Apache Portable Runtime Utility Library - Debugging Symbols
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 APR Util is a utilities library implemented on top of apr, providing database
 access, xml parsing, and other useful functionality.
 .
 This package contains the debugging symbols for APR util.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# for ppc64 on Ubuntu
export DEB_GCC_NO_O3=1

SHELL    := /bin/bash
BUILDDIR := debian/build

DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# configure takes ages to test for all db versions. Provide the installed
# version to speed things up.
DB_VERSION = $(shell dpkg-query -W -f '$${Version}' libdb-dev | \
	       perl -pe 's/^(?:[^:]*:)?(\d+)[.](\d+)[.].*/$$1$$2/')

# The 'build' target needs special handling because there there is a directory
# named 'build'.
.PHONY: build
build %:
	dh $@ -B$(BUILDDIR) --parallel --with autotools_dev

#
# configure
#
CONFFLAGS := LTFLAGS=--no-silent \
	     --host=$(DEB_HOST_GNU_TYPE) \
	     --build=$(DEB_BUILD_GNU_TYPE) \
	     --with-apr=/usr/bin/apr-1-config \
	     --enable-layout=Debian \
	     --includedir=/usr/include/apr-1.0 \
	     --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	     --with-ldap=yes \
	     --with-dbm=db$(DB_VERSION) \
	     --with-sqlite3 \
	     --with-pgsql=/usr \
	     --without-gdbm \
	     --without-sqlite2 \
	     --with-berkeley-db \
	     --with-mysql=/usr \
	     --with-odbc=/usr \
	     --with-openssl=/usr \
	     --with-crypto \
	     ac_cv_prog_AWK=mawk

# files that are modified by buildconf and need to be restored during clean
SAVE_FILES := configure build/apr_common.m4

ifeq ($(DEB_HOST_ARCH),i386)
	CONFFLAGS += apr_lock_method=USE_PROC_PTHREAD_SERIALIZE
else
	CONFFLAGS += ac_cv_func_pthread_mutexattr_setpshared=no \
		     ac_cv_func_sem_open=no
endif

override_dh_auto_configure:
	mkdir -p $(BUILDDIR)/docs
	for f in $(SAVE_FILES) ; do [ -e $$f.dr-orig ] || cp -p $$f $$f.dr-orig ; done
	./buildconf --with-apr=$(shell apr-1-config --srcdir)
	cd $(BUILDDIR) && $(CURDIR)/configure $(CONFFLAGS)

#
# build
#

# get cflags from apr-config but remove -O2
export DEB_CFLAGS_MAINT_PREPEND := $(shell apr-1-config --cflags |perl -p -e 's!-O.( |$$)!!')
export DEB_LDFLAGS_MAINT_PREPEND := $(shell apr-1-config --ldflags)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEARGS := -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

override_dh_auto_build:
	dh_auto_build --parallel -B$(BUILDDIR)
	$(MAKE) $(MAKEARGS) -C $(BUILDDIR) dox

#
# test
#

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	$(MAKE) -C $(BUILDDIR)/test $(MAKEARGS) all
	$(MAKE) -C $(BUILDDIR)/test -j1 check

else
override_dh_auto_test:

endif

#
# install
#
override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
	perl -p -i -e "s,^dependency_libs=.*,dependency_libs=''," debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libaprutil-1.la

override_dh_strip:
	dh_strip --dbg-package=libaprutil1-dbg

# The -X option causes the internal-use-only driver libs to be ignored
override_dh_makeshlibs:
	dh_makeshlibs -Xapr-util-1 -- -Idebian/symbols.$(DEB_HOST_ARCH_OS)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)
	for f in $(SAVE_FILES) ; do [ ! -e $$f.dr-orig ] || mv $$f.dr-orig $$f ; done

## apr-util 1.5.4

=== debian/changelog ===
apr-util (1.5.4-3) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix unsatisfiable cross Build-Depends: (Closes: #840892)
    + Drop binutils from Build-Depends as it is build-essential.
    + Annotate Build-Depends: python with :any.

  [ Stefan Fritsch ]
  * Enable support for gdbm. Closes: #843206
  * Switch build-depends to default-libmysqlclient-dev. Closes: #845823

 -- Stefan Fritsch <sf@debian.org>  Fri, 09 Dec 2016 18:19:55 +0100

apr-util (1.5.4-2) unstable; urgency=medium

  [ Jean-Michel Vourgère ]
  * d/watch: Check gpg signature of upstream source.
  * Update Vcs-Browser: address.

  [ Stefan Fritsch ]
  * Bump standards version. No changes needed.
  * Backport support for openssl 1.1 from upstream 1.5.x branch.
    Closes: #828237

 -- Stefan Fritsch <sf@debian.org>  Thu, 14 Jul 2016 12:00:56 +0200

apr-util (1.5.4-1) unstable; urgency=medium

  * New upstream release
  * Remove dependencies on libpcre3-dev, libsqlite3-dev, libpq-dev,
    and libmysqlclient-dev in libaprutil1-dev. They are no longer
    necessary. Closes: #757140
  * Bump standards version. No changes needed.

 -- Stefan Fritsch <sf@debian.org>  Sat, 04 Oct 2014 14:19:46 +0200

apr-util (1.5.3-3) unstable; urgency=medium

  * Allow building with libmariadbclient-dev instead of
    libmysqlclient-dev. Closes: #759158
  * Update Vcs-Git URL in control file.

 -- Stefan Fritsch <sf@debian.org>  Mon, 25 Aug 2014 22:10:38 +0200

apr-util (1.5.3-2) unstable; urgency=medium

  * Fix FTBFS with make 4.0. Closes: #748369

 -- Stefan Fritsch <sf@debian.org>  Thu, 29 May 2014 16:52:08 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
 Uploaders: Stefan Fritsch <sf@debian.org>, Peter Samuelson <peter@p12n.org>
-Build-Depends: debhelper (>> 9~), autoconf, autotools-dev, mawk, libldap2-dev, libexpat1-dev, libdb-dev, libpcre3-dev, binutils, libapr1-dev (>> 1.4.8-2~), libsqlite3-dev, libpq-dev, python, libmysqlclient-dev, unixodbc-dev, doxygen, libssl-dev
-Standards-Version: 3.9.5
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-apache/apr-util.git
-Vcs-Git: git://git.debian.org/git/pkg-apache/apr-util.git
+Build-Depends: debhelper (>> 9~), autoconf, autotools-dev, mawk, libldap2-dev, libexpat1-dev, libdb-dev, libgdbm-dev, libpcre3-dev, libapr1-dev (>> 1.4.8-2~), libsqlite3-dev, libpq-dev, python:any, default-libmysqlclient-dev, unixodbc-dev, doxygen, libssl-dev
+Standards-Version: 3.9.8
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-apache/apr-util.git
+Vcs-Git: git://anonscm.debian.org/pkg-apache/apr-util.git
 Homepage: http://apr.apache.org/
 
 Package: libaprutil1
@@ -51,7 +51,7 @@
  APR Util is a utilities library implemented on top of apr, providing database
  access, xml parsing, and other useful functionality.
  .
- This package contains the MySQL database driver.
+ This package contains the MySQL / mariadb database driver.
 
 Package: libaprutil1-dbd-sqlite3
 Architecture: any
@@ -101,7 +101,7 @@
 Package: libaprutil1-dev
 Architecture: any
 Section: libdevel
-Depends: libaprutil1 (= ${binary:Version}), libldap2-dev, libexpat1-dev, libpcre3-dev, libapr1-dev (>= 1.2.2-1), libsqlite3-dev, libpq-dev, libmysqlclient-dev, ${misc:Depends}
+Depends: libaprutil1 (= ${binary:Version}), libldap2-dev, libexpat1-dev, libapr1-dev (>= 1.2.2-1), ${misc:Depends}
 Description: Apache Portable Runtime Utility Library - Development Headers
  APR is Apache's Portable Runtime Library, designed to be a support library 
  that provides a predictable and consistent interface to underlying

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 # The 'build' target needs special handling because there there is a directory
 # named 'build'.
 .PHONY: build
-build %:
+%:
 	dh $@ -B$(BUILDDIR) --parallel --with autotools_dev
 
 #
@@ -39,7 +39,7 @@
 	     --with-dbm=db$(DB_VERSION) \
 	     --with-sqlite3 \
 	     --with-pgsql=/usr \
-	     --without-gdbm \
+	     --with-gdbm \
 	     --without-sqlite2 \
 	     --with-berkeley-db \
 	     --with-mysql=/usr \

## apr-util 1.6.0

=== debian/changelog ===
apr-util (1.6.0-2) unstable; urgency=medium

  * Switch off FULL_PATH_NAMES in doxygen to make builds reproducible.
  * Bump Standards-Version:
    - remove "Priority: extra" in control

 -- Stefan Fritsch <sf@debian.org>  Fri, 11 Aug 2017 17:49:25 +0200

apr-util (1.6.0-1) unstable; urgency=medium

  * New upstream release
  * Remove Peter Samuelson from uploaders. Thanks for your work in the past.
    Closes: #852221

 -- Stefan Fritsch <sf@debian.org>  Fri, 04 Aug 2017 21:37:03 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: libs
 Priority: optional
 Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
-Uploaders: Stefan Fritsch <sf@debian.org>, Peter Samuelson <peter@p12n.org>
+Uploaders: Stefan Fritsch <sf@debian.org>
 Build-Depends: debhelper (>> 9~), autoconf, autotools-dev, mawk, libldap2-dev, libexpat1-dev, libdb-dev, libgdbm-dev, libpcre3-dev, libapr1-dev (>> 1.4.8-2~), libsqlite3-dev, libpq-dev, python:any, default-libmysqlclient-dev, unixodbc-dev, doxygen, libssl-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.1
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-apache/apr-util.git
 Vcs-Git: git://anonscm.debian.org/pkg-apache/apr-util.git
 Homepage: http://apr.apache.org/
@@ -113,7 +113,6 @@
  This package contains development headers for APR util.
 
 Package: libaprutil1-dbg
-Priority: extra
 Architecture: any
 Section: debug
 Depends: libaprutil1 (= ${binary:Version}), ${misc:Depends}
